from __future__ import annotations

import flatbuffers
import numpy as np

import flatbuffers
import typing
from flatflow.ops.graph_generated import Graph

uoffset: typing.TypeAlias = flatbuffers.number_types.UOffsetTFlags.py_type

class InitRequest(object):
  @classmethod
  def GetRootAs(cls, buf: bytes, offset: int) -> InitRequest: ...
  @classmethod
  def GetRootAsInitRequest(cls, buf: bytes, offset: int) -> InitRequest: ...
  def Init(self, buf: bytes, pos: int) -> None: ...
  def GlobalBatchSize(self) -> int: ...
  def MicroBatchSize(self) -> int: ...
  def Graph(self) -> Graph | None: ...
  def Sizes(self, i: int) -> typing.List[int]: ...
  def SizesAsNumpy(self) -> np.ndarray: ...
  def SizesLength(self) -> int: ...
  def SizesIsNone(self) -> bool: ...
def InitRequestStart(builder: flatbuffers.Builder) -> None: ...
def InitRequestAddGlobalBatchSize(builder: flatbuffers.Builder, globalBatchSize: int) -> None: ...
def InitRequestAddMicroBatchSize(builder: flatbuffers.Builder, microBatchSize: int) -> None: ...
def InitRequestAddGraph(builder: flatbuffers.Builder, graph: uoffset) -> None: ...
def InitRequestAddSizes(builder: flatbuffers.Builder, sizes: uoffset) -> None: ...
def InitRequestStartSizesVector(builder: flatbuffers.Builder, num_elems: int) -> uoffset: ...
def InitRequestEnd(builder: flatbuffers.Builder) -> uoffset: ...
class BroadcastRequest(object):
  @classmethod
  def GetRootAs(cls, buf: bytes, offset: int) -> BroadcastRequest: ...
  @classmethod
  def GetRootAsBroadcastRequest(cls, buf: bytes, offset: int) -> BroadcastRequest: ...
  def Init(self, buf: bytes, pos: int) -> None: ...
  def Epoch(self) -> int: ...
  def Rank(self) -> int: ...
  def Indices(self, i: int) -> typing.List[int]: ...
  def IndicesAsNumpy(self) -> np.ndarray: ...
  def IndicesLength(self) -> int: ...
  def IndicesIsNone(self) -> bool: ...
def BroadcastRequestStart(builder: flatbuffers.Builder) -> None: ...
def BroadcastRequestAddEpoch(builder: flatbuffers.Builder, epoch: int) -> None: ...
def BroadcastRequestAddRank(builder: flatbuffers.Builder, rank: int) -> None: ...
def BroadcastRequestAddIndices(builder: flatbuffers.Builder, indices: uoffset) -> None: ...
def BroadcastRequestStartIndicesVector(builder: flatbuffers.Builder, num_elems: int) -> uoffset: ...
def BroadcastRequestEnd(builder: flatbuffers.Builder) -> uoffset: ...
class BroadcastResponse(object):
  @classmethod
  def GetRootAs(cls, buf: bytes, offset: int) -> BroadcastResponse: ...
  @classmethod
  def GetRootAsBroadcastResponse(cls, buf: bytes, offset: int) -> BroadcastResponse: ...
  def Init(self, buf: bytes, pos: int) -> None: ...
  def Indices(self, i: int) -> typing.List[int]: ...
  def IndicesAsNumpy(self) -> np.ndarray: ...
  def IndicesLength(self) -> int: ...
  def IndicesIsNone(self) -> bool: ...
def BroadcastResponseStart(builder: flatbuffers.Builder) -> None: ...
def BroadcastResponseAddIndices(builder: flatbuffers.Builder, indices: uoffset) -> None: ...
def BroadcastResponseStartIndicesVector(builder: flatbuffers.Builder, num_elems: int) -> uoffset: ...
def BroadcastResponseEnd(builder: flatbuffers.Builder) -> uoffset: ...

